﻿using System;

namespace _4InARow
{
    class Handler
    {
        int rows = 6;
        int columns = 7;

        int numberOfFisches = 0;
        Fisch[] fisch;
        string whosTurn = "Red";

        public Handler(int Rows = 6, int Columns = 7)
        {
            this.rows = Rows;
            this.columns = Columns;
            this.numberOfFisches = rows * columns;
            fisch = new Fisch[numberOfFisches];

            startUp();
        }

        void startUp()
        {
            for (int i = 0; i < numberOfFisches; i++)
            {
                if (fisch[i] == null)
                {
                    fisch[i] = new Fisch();
                }
                else
                {
                    fisch[i].fischColor = Fisch_Box.None;
                    fisch[i].Refresh();
                }
            }
            game();
        }

        void game()
        {
            rack();
            bool stop = false;
            bool won = false;

            Console.Write(System.Environment.NewLine + System.Environment.NewLine + "It is ");
            Console.ForegroundColor = whichColor();
            Console.Write(whosTurn);
            Console.ResetColor();
            Console.Write("'s turn." + System.Environment.NewLine + "Row: ");

            try
            {
                int Rw = Convert.ToInt32(Console.ReadLine());
                Console.Write("Column: ");
                int where = whichArray(Rw, Convert.ToInt32(Console.ReadLine()));

                if (where + columns <= (rows * columns) - columns)
                    if (fisch[where + columns].fischColor == Fisch_Box.None)
                        stop = true;

                if (!stop)
                {
                    if (fisch[where].fischColor != Fisch_Box.Red && fisch[where].fischColor != Fisch_Box.Yellow)
                    {
                        if (whosTurn == "Red")
                            fisch[where].fischColor = Fisch_Box.Red;
                        else
                            fisch[where].fischColor = Fisch_Box.Yellow;
                    }

                    #region stuffAboutWon
                    won = hasWon(where, columns);
                    if (won != true)
                    {
                        won = hasWon(where, -columns);
                        if (won != true)
                        {
                            won = hasWon(where, 1, 1);
                            if (won != true)
                            {
                                won = hasWon(where, -1, 1);
                                if (won != true)
                                {
                                    won = hasWon(where, columns, 2, false);
                                    if (won != true)
                                    {
                                        won = hasWon(where, -columns, 2, true);
                                    }
                                }
                            }
                        }
                    }
                    #endregion
                    changeTurns();
                }
            }
            catch { }

            if (won)
            {
                changeTurns();
                this.won();
            }
            else
            {
                game();
            }
        }

        void rack()
        {
            int writeColumn = 0;
            int rw = 1;
            bool firstTime = true;
            string columnString = "";

            for (int i = 1; i < (columns + 1); i++)
            {
                columnString = columnString + i.ToString();
            }

            Console.Clear();

            for (int i = 0; i < numberOfFisches; i++)
            {
                if (writeColumn == columns && rw != rows)//should be ==, but I don't want to mess it up completely if an error occurs.
                {
                    rw++;
                    Console.ForegroundColor = ConsoleColor.White;
                    Console.Write(System.Environment.NewLine + rw.ToString() + " ");
                    writeColumn = 0;
                }

                if (firstTime)
                {
                    Console.ForegroundColor = ConsoleColor.White;
                    Console.Write("  " + columnString + System.Environment.NewLine + "1 ");
                    firstTime = false;
                }
                fisch[i].Refresh();
                Console.ForegroundColor = fisch[i].clr;
                Console.Write(fisch[i].fisch);
                writeColumn++;
            }
            Console.ResetColor();
        }

        void won()
        {
            rack();
            Console.ForegroundColor = whichColor();
            Console.Write(System.Environment.NewLine + System.Environment.NewLine + whosTurn + " ");
            Console.ResetColor();
            Console.Write("has won! Congratulations!" + System.Environment.NewLine + "Would you like to play again? (Y / N)" + System.Environment.NewLine);

            string answer = Console.ReadLine();
            if (answer.ToLower() == "yes" || answer.ToLower().Substring(0) == "y")
            {
                startUp();
            }
        }

        void changeTurns()
        {
            if (whosTurn == "Red")
            {
                whosTurn = "Yellow";
            }
            else
            {
                whosTurn = "Red";
            }
        }

        int whichArray(int row, int column)
        {
            row = (row - 1) * this.columns;
            column -= 1;
            return row + column;
        }

        ConsoleColor whichColor()
        {
            if (whosTurn == "Red")
            {
                return ConsoleColor.Red;
            }
            else
            {
                return ConsoleColor.Yellow;
            }
        }

        bool hasWon(int who, int attribute, int direction = 0, bool isMinus = false)
        {
            try
            {
                Fisch_Box clr = fisch[who].fischColor;

                if (direction == 0)//vertical
                {
                    if (fisch[who + attribute].fischColor == clr && fisch[who + (attribute + attribute)].fischColor == clr && fisch[who + (attribute * 3)].fischColor == clr)
                        return true;
                    else
                        return false;
                }
                else if (direction == 1)//horizontal
                {
                    if (fisch[who + attribute].fischColor == clr && fisch[who + (attribute + attribute)].fischColor == clr && fisch[who + (attribute * 3)].fischColor == clr)
                        return true;
                    else
                        return false;
                }
                else //vertical / horizontal(angled)
                {
                    if (isMinus)
                    {
                        if (fisch[who + attribute - 1].fischColor == clr && fisch[who + (attribute + attribute) - 2].fischColor == clr && fisch[who + (attribute * 3) - 3].fischColor == clr)
                            return true;
                        else
                            return false;
                    }
                    else
                    {
                        if (fisch[who + attribute + 1].fischColor == clr && fisch[who + (attribute + attribute) + 2].fischColor == clr && fisch[who + (attribute * 3) + 3].fischColor == clr)
                            return true;
                        else
                            return false;
                    }
                }
            }
            catch
            {
                return false;
            }
        }
    }

    enum Fisch_Box
    {
        None,
        Yellow,
        Red
    }

    class Fisch
    {
        public Fisch_Box fischColor = Fisch_Box.None;
        public string fisch = "O";
        public ConsoleColor clr = ConsoleColor.White;

        public Fisch() { }

        public void Refresh()
        {
            //Check the colors
            if (fischColor == Fisch_Box.Red) // RED
            {
                fisch = "R";
                clr = ConsoleColor.Red;
            }
            else if (fischColor == Fisch_Box.Yellow) // YELLOW
            {
                fisch = "Y";
                clr = ConsoleColor.Yellow;
            }
            else //NO FISCH
            {
                clr = ConsoleColor.White;
                fisch = "O";
            }
        }
    }

}
